"use strict";
var app = angular.module('ng-laravel');

app.controller('ProductListCtrl', function ($scope, ProductService, $stateParams, $http, resolvedItems, $translatePartialLoader,$rootScope,trans,Notification) {

	/*
     * Define initial value
     */

    $scope.query = '';
	$scope.status = 'Checking status...';

    /*
     * Get all Products
     * Get from resolvedItems function in this page route (config.router.js)
     */

	$scope.products = resolvedItems;
    $scope.pagination = $scope.products.metadata;
    $scope.maxSize = 2;

	/*
     * Get all Product and refresh cache.
     * At first check cache, if exist, we return data from cache and if don't exist return from API
     */

	ProductService.list().then(function (data) {		
		$scope.products = data;
		$scope.pagination = $scope.products.metadata;		
		if($scope.pagination.total == 0) {
			$scope.fetchStatus();
		}
	});
	
	$scope.popupUpdatePdesc = function (product) {
		$scope.productobj = product;
	};
	
	$scope.updatePDesc = function (productobj) {
		$scope.loader = true;
		$scope.isDisabled = true;
		var data = {'product_id': productobj.product_id, 'description': productobj.description};
		ProductService.updatePDesc(data);
	};

	$scope.popupvariants = function (product_id) {
		for(var i=0; i < $scope.products.length; i++) {
			if($scope.products[i].product_id == product_id.id) {
				$scope.popupvariant = $scope.products[i].variants;
				$scope.popupoption1 = $scope.products[i].option1name;
				$scope.popupoption2 = $scope.products[i].option2name;
				$scope.popupoption3 = $scope.products[i].option3name;
				$scope.popupoption4 = $scope.products[i].option4name;
				$scope.popupoption5 = $scope.products[i].option5name;
			}
		}
	};

	$scope.popupvariantsnew = function (product_id, option1name, option2name, option3name, option4name, option5name) {
		$scope.loader = true;
		$scope.popupvariant = [];
		ProductService.getVariants(product_id).then(function (data) {
			$scope.loader = false;
			$scope.popupvariant = data;
			$scope.popupoption1 = option1name;
			$scope.popupoption2 = option2name;
			$scope.popupoption3 = option3name;
			$scope.popupoption4 = option4name;
			$scope.popupoption5 = option5name;
			
		});
	};

	/*
     * Pagination product list
     */
	$scope.units = [
        {'id': 10, 'label': '10'},
		{'id': 20, 'label': '20'},
        {'id': 50, 'label': '50'},
        {'id': 100, 'label': '100'},
    ]
	if($scope.profile.id == '3020'){
		$scope.units = [
        	{'id': 10, 'label': '10'},
			{'id': 20, 'label': '20'},
        	{'id': 50, 'label': '50'},
        	{'id': 100, 'label': '100'},
        	{'id': 500, 'label': '500'},
        	{'id': 1000, 'label': '1000'},
        	{'id': 1500, 'label': '1500'}
    	]
	}
	$scope.perPage = $scope.units[1];
	
	if($scope.perPage.id < $scope.pagination.total) {
		$scope.start = 1;
		$scope.end = $scope.perPage.id;
	} else {
		$scope.start = 1;
		$scope.end = $scope.pagination.total;
	}	

	$scope.pageChanged = function (per_page) {
		$scope.loader = true;
		if($scope.query == '') {
			ProductService.pageChange($scope.pagination.current_page, per_page.id,$scope.end,$scope.pagination.total).then(function (data) {
	            $scope.loader = false;
				$scope.products = data;
				$scope.pagination = $scope.products.metadata;
				$scope.maxSize = 2;
				if(($scope.pagination.current_page * per_page.id) < $scope.pagination.total) {
					$scope.start = $scope.pagination.current_page * per_page.id - per_page.id + 1;
					$scope.end = $scope.pagination.current_page * per_page.id;			
				} else {
					$scope.start = $scope.pagination.current_page * per_page.id - per_page.id + 1;
					$scope.end = $scope.pagination.total;	
				}
			});
		} else { 
			ProductService.search($scope.query, per_page.id, $scope.pagination.current_page, $scope.end, $scope.pagination.total).then(function (data) {
				$scope.loader = false;
				$scope.products = data;
				$scope.pagination = $scope.products.metadata;
				$scope.maxSize = 2;
				if(($scope.pagination.current_page * per_page.id) < $scope.pagination.total) {
					$scope.start = $scope.pagination.current_page * per_page.id - per_page.id + 1;
					$scope.end = $scope.pagination.current_page * per_page.id;			
				} else {
					$scope.start = $scope.pagination.current_page * per_page.id - per_page.id + 1;
					$scope.end = $scope.pagination.total;	
				}
			});
		} 
	};

	/*
     * Search in Product
     */
	$scope.search = function (per_page) {
		$scope.loader = true;
		ProductService.search($scope.query, per_page.id).then(function (data) {	
			$scope.loader = false;
			$scope.products = data;
			$scope.pagination = $scope.products.metadata;			
            $scope.maxSize = 2;
			if(($scope.pagination.current_page * per_page.id) < $scope.pagination.total) {
				$scope.start = $scope.pagination.current_page * per_page.id - per_page.id + 1;
				$scope.end = $scope.pagination.current_page * per_page.id;			
			} else {
				$scope.start = $scope.pagination.current_page * per_page.id - per_page.id + 1;
				$scope.end = $scope.pagination.total;	
			}
		});
	};

	$scope.refresh = function(){
		$scope.loader = true;
		$scope.query = '';
		ProductService.list().then(function (data) {
			$scope.loader = false;
			$scope.products = data;
			$scope.pagination = $scope.products.metadata;
			$scope.maxSize = 2;
			$scope.perPage = $scope.units[1];
			var per_page = $scope.perPage;
			if(($scope.pagination.current_page * per_page.id) < $scope.pagination.total) {
				$scope.start = $scope.pagination.current_page * per_page.id - per_page.id + 1;
				$scope.end = $scope.pagination.current_page * per_page.id;			
			} else {
				$scope.start = $scope.pagination.current_page * per_page.id - per_page.id + 1;
				$scope.end = $scope.pagination.total;	
			}
			//$scope.start = 1;
			//$scope.end = $scope.perPage.id;
		});
	}

    $scope.updateAppSwitch = function() {
        //console.log("hehhehhrhrjkjkhjk");
    
        const key=$scope.profile.id;
        // console.log($scope.profile.id);
    
        window.location.href = 'https://cp.infoshoreapps.com/serverRequest.php?sbkey='+key;
    };
	$scope.fetchStatus = function(){
		ProductService.fetchStatus().then(function (data) {
			console.log(data);	
			if(data.status == 'EB_KEY_NOT_EXIST'){
				$scope.status = "You have not added eBay account yet. Please add your eBay account to start fetching the products!";
			} else if (data.status == 'REQUEST_IN_PROGRESS') {
				$scope.status = "Your eBay account setup is in progress to fetch items for our app. Please check back later. You will receive a notification from us once the process is complete.";
			} else if (data.status == 'NO_ACTIVE_PRODUCT') {
				$scope.status = "Your eBay account does not have any active products.";
			}
            			
		});
	}

	/*
     * pushall selected Products
     */

    $scope.pushall = function (product) {
		$scope.loader = true;
		if($scope.profile.membershiptype == 'free'){
			var errmsg = {"msg": ["The selected Products feature is not allowed in the trial plan. Please upgrade your plan to use the selected Products feature."]};
			Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			$scope.loader = false;
		}
		else{
		ProductService.pushall(product);
		}
	};

	/*
     * push selected Products
     */
	//console.log($scope.profile);
	//console.log("user_id",$scope.profile);
	//console.log("user_id",$scope.profile.id);
	/*$scope.push = function (product) {
         
		if($scope.profile.membershiptype == 'free'){

			if(product.length > 1 ){
				var errmsg = {"msg": ["The selected Products feature is not allowed in the trial plan. Please upgrade your plan to use the selected Products feature."]};
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
				for(var i = 0; i < $scope.products.length; i++) {
					if($scope.products[i].product_id == product) {
					
					   $scope.removeSelection($scope.products[i].product_id);
						break;
					}
				}
			}
			 else{
			if($scope.profile.skulimit <= $scope.profile.skuconsumed){
				console.log("inelsefdgdhdh");
				var errmsg = {"msg": [`You have imported ${$scope.profile.skuconsumed} as per your limit ${$scope.profile.skulimit}.Please upgrade your plan to continue using our services.`]};
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}
			else{
				console.log("inelse");
			           Notification({message: 'product.form.productPushSuccess', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
						for(var i = 0; i < $scope.products.length; i++) {
							if($scope.products[i].product_id == product) {
								$scope.products[i].status = "Import in progress";
							   $scope.removeSelection($scope.products[i].product_id);
								break;
							}
						}
			$.ajax({
                url: 'https://cp.infoshoreapps.com/cronjobs/processimporttrial.php',  // Backend PHP file URL
                type: 'POST',
                data: { sbkey: $scope.profile.id,productIdall:product,skuconsumed:$scope.profile.skuconsumed,skulimit:$scope.profile.skulimit },  // Send sbkey (user_id) to the backend
                success: function(response) {
                    // Handle the success response from the backend
                    //alert('Import successful: ' + response);
					if(response == 'The number of eBay listings you want to import is more than your allowed limit. Please upgrade your plan.'){
						var errmsg = {"msg": ["The number of eBay listings you want to import is more than your allowed limit. Please upgrade your plan."]};
						Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
					}
					else{

						for(var i = 0; i < $scope.products.length; i++) {
							if($scope.products[i].product_id == product) {
								//$scope.products[i].status = "Imported";
								
								$scope.removeSelection($scope.products[i].product_id);
								break;
							}
						}
							 // Update skuconsumed and ensure Angular updates the scope
							 $scope.$apply(function() {
								$scope.profile.skuconsumed = response.skuconsumed || response;  // Handle response properly
							});
						
					}
                },
                
            });
	    	}
	     	}
		}
		else {
		var errmsg = {"msg": ["Please choose a product to import."]};
		if(Array.isArray(product)){
			if(product.length > 0){
				$scope.loader = true;
				ProductService.push(product);	
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}				
		} else {
			if(product){
				$scope.loader = true;
				ProductService.push(product);
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}
		}
	   }

    };
	*/
   ///push product
   $scope.push = function (product) {
         
	if($scope.profile.membershiptype == 'free'){
		
		if(Array.isArray(product)){
			
			 var errmsg = {"msg": ["The selected Products feature is not allowed in the trial plan. Please upgrade your plan to use the selected Products feature."]};
			 Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			   for(var i = 0; i < $scope.products.length; i++) {
				if($scope.products[i].product_id == product) {
					$scope.$apply(function() {
						$scope.removeSelection($scope.products[i].product_id); // Handle response properly
		              });
				  
					
				}
			  }
			
		}
		else{
			
			if(product){
			
				if($scope.profile.skulimit <= $scope.profile.skuconsumed){
				
					var errmsg = {"msg": [`You have reached the import limit allowed under our trial plan. Please upgrade your plan to continue using our services.`]};
					Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
				}
				else{
					Notification({message: 'product.form.productPushSuccess', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
					for(var i = 0; i < $scope.products.length; i++) {
						if($scope.products[i].product_id == product) {
							$scope.products[i].status = "Import in progress";
						   $scope.removeSelection($scope.products[i].product_id);
							break;
						}
					}
					$.ajax({
						url: 'https://cp.infoshoreapps.com/cronjobs/processimporttrial.php',  // Backend PHP file URL
						type: 'POST',
						data: { sbkey: $scope.profile.id,productIdall:product,skuconsumed:$scope.profile.skuconsumed,skulimit:$scope.profile.skulimit },  // Send sbkey (user_id) to the backend
						success: function(response) {
							$scope.$apply(function() {
										$scope.profile.skuconsumed = response.skuconsumed || response;  // Handle response properly
						   });
						},
						
					});
					 
				}

			} else {
				console.log("yes222");
				var errmsg = {"msg": ["Please choose a product to import."]};
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}
		}
			
	}
	else {
	var errmsg = {"msg": ["Please choose a product to import."]};
	if(Array.isArray(product)){
		if(product.length > 0){
			$scope.loader = true;
			ProductService.push(product);	
		} else {
			Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
		}				
	} else {
		if(product){
			$scope.loader = true;
			ProductService.push(product);
		} else {
			Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
		}
	}
   }

};


	/*
     * unblock selected Products
     */
	$scope.unblock = function (product) {
		var errmsg = {"msg": ["Please choose a product to unblock."]};
		if(Array.isArray(product)){
			if(product.length > 0){
				$scope.loader = true;
				ProductService.unblock(product);
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}				
		} else {
			if(product){
				$scope.loader = true;
				ProductService.unblock(product);
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}
		}				


	};

	/*
     * block selected Products
     */
    $scope.block = function (product) {
		var errmsg = {"msg": ["Please choose a product to block."]};
		if(Array.isArray(product)){
			if(product.length > 0){
				$scope.loader = true;
				ProductService.block(product);
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}				
		} else {
			if(product){
				$scope.loader = true;
				ProductService.block(product);
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}
		}		
    };

	/*
     * reimport selected Products
     */
	$scope.reimport = function (product) {
		if($scope.profile.membershiptype == 'free'){
			var errmsg = {"msg": ["The reimport feature is not allowed in the trial plan. Please upgrade your plan to use the reimport feature."]};
			Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
		}
		else{
		var errmsg = {"msg": ["Please choose a product to import."]};
		if(Array.isArray(product)){
			if(product.length > 0){
				$scope.loader = true;
				ProductService.reimport(product);	
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}				
		} else {
			if(product){
				$scope.loader = true;
				ProductService.reimport(product);
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}
		}
	  }
    };

	/*
     * remove selected Products
     */
	$scope.remove = function (product) {
		var errmsg = {"msg": ["Please choose a product to import."]};
		if(Array.isArray(product)){
			if(product.length > 0){
				$scope.loader = true;
				ProductService.remove(product);	
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}				
		} else {
			if(product){
				$scope.loader = true;
				ProductService.remove(product);
			} else {
				Notification({message: errmsg, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
			}
		}
    };

    /**********************************************************
     * Event Listener
     **********************************************************/

	// Get list of selected product to do actions
    $scope.selection = [];
	$scope.selectedAll = false;
	$scope.checkAll = function () {		
	
	if ($scope.selectedAll) {
		$scope.selectedAll = true;				
	} else {
		$scope.selectedAll = false;
	}

	angular.forEach($scope.products, function (product) {
		 product.Selected = $scope.selectedAll;
		 $scope.toggleSelection(product.product_id);
		});
	};

	$scope.toggleSelection = function toggleSelection(productId) {
	
	// toggle selection for a given product by Id
	var idx = $scope.selection.indexOf(productId);
		// is currently selected
		if (idx > -1) {
			$scope.selection.splice(idx, 1);
        } else {
			$scope.selection.push(productId);
        }
    };

	$scope.removeSelection = function removeSelection(productId) {
		// toggle selection for a given product by Id
		var idx = $scope.selection.indexOf(productId);
		// is currently selected
		if (idx > -1) {
			$scope.selection.splice(idx, 1);
        }
    };

    $scope.$on('product.push', function (event, data, skuconsumed) {
		$scope.loader = false;
        if(Array.isArray(data)){
			Notification({message: 'product.form.productPushSuccessP', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($.inArray($scope.products[i].product_id, data) > -1) {
					$scope.products[i].status = "Import in progress";
					$scope.removeSelection($scope.products[i].product_id);
				}
			}
			$scope.selectedAll = '';
			$scope.profile.skuconsumed = skuconsumed;
		} else {
			Notification({message: 'product.form.productPushSuccess', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($scope.products[i].product_id == data) {
					$scope.products[i].status = "Import in progress";
					$scope.removeSelection($scope.products[i].product_id);
					break;
				}
			}
			$scope.profile.skuconsumed = skuconsumed;
		}		
    });
  

    $scope.$on('product.block', function (event, data) {
		$scope.loader = false;
		if(Array.isArray(data)){
			Notification({message: 'product.form.productBlockSuccessP', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($.inArray($scope.products[i].product_id, data) > -1) {
					$scope.products[i].block = 1;
					$scope.removeSelection($scope.products[i].product_id);
				}
			}
			$scope.selectedAll = '';
		} else {
			Notification({message: 'product.form.productBlockSuccess', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($scope.products[i].product_id == data) {
					$scope.products[i].block = 1;
					$scope.removeSelection($scope.products[i].product_id);
					break;
				}
			}
		}		
    });


    $scope.$on('product.unblock', function (event, data) {
		$scope.loader = false;
        if(Array.isArray(data)){
			Notification({message: 'product.form.productUnblockSuccessP' ,templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($.inArray($scope.products[i].product_id, data) > -1) {
					$scope.products[i].block = 0;
					$scope.removeSelection($scope.products[i].product_id);
				}
			}
			$scope.selectedAll = '';
		} else {
			Notification({message: 'product.form.productUnblockSuccess' ,templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($scope.products[i].product_id == data) {
					$scope.products[i].block = 0;
					$scope.removeSelection($scope.products[i].product_id);
					break;
				}
			}
		}		
    });

    $scope.$on('product.pushall', function (event, skuconsumed) {
		
		Notification({message: 'product.form.productPushAllSuccess' ,templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
		$scope.profile.skuconsumed = skuconsumed;
		ProductService.list().then(function (data) {
			$scope.loader = false;
			$scope.products = data;
            $scope.selection = [];
        });
    });

    $scope.$on('product.validationError', function(event,errorData) {
		$scope.loader = false;
		ProductService.list().then(function (data) {
			//$scope.products = data;
            $scope.selection = [];
			$scope.selectedAll= '';
        });
		Notification({message: errorData, templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'}, 'warning');
		$scope.isDisabled = false;
	});

	$scope.$on('product.updatepdesc', function (event, data) {
		$scope.loader = false;
		$scope.isDisabled = false;
		Notification({message: 'product.form.updatePDataSuccess', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
		$('#updatePDescModal').modal('hide');
    });

	$scope.$on('product.reimport', function (event, data) {
		$scope.loader = false;
        if(Array.isArray(data)){
			Notification({message: 'product.form.reimportPushSuccessP', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($.inArray($scope.products[i].product_id, data) > -1) {
					$scope.products[i].status = "reimport in progress";
					$scope.removeSelection($scope.products[i].product_id);
				}
			}
			$scope.selectedAll = '';
		} else {
			Notification({message: 'product.form.reimportPushSuccess', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($scope.products[i].product_id == data) {
					$scope.products[i].status = "reimport in progress";
					$scope.removeSelection($scope.products[i].product_id);
					break;
				}
			}
		}		
    });

	$scope.$on('product.remove', function (event, data) {
		$scope.loader = false;
        if(Array.isArray(data)){
			Notification({message: 'product.form.removeSuccessP', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($.inArray($scope.products[i].product_id, data) > -1) {
					$scope.products[i].status = "Ready to Import";
					$scope.removeSelection($scope.products[i].product_id);
				}
			}
			$scope.selectedAll = '';
		} else {
			Notification({message: 'product.form.removeSuccess', templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
			for(var i = 0; i < $scope.products.length; i++) {
				if($scope.products[i].product_id == data) {
					$scope.products[i].status = "Ready to Import";
					$scope.removeSelection($scope.products[i].product_id);
					break;
				}
			}
		}		
    });
});